﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.31
@EndOfDesignText@
'Static code module
Sub Process_Globals
End Sub

private Sub getMap(amap As Map,akey As String,adefault) As Object
	Return amap.GetDefault(akey,adefault)
End Sub

private Sub getList(alist As List,akey As Int,adefault) As Object
	If akey>=0 And akey<=alist.Size Then
		Return alist.Get(akey)
	Else
		Return adefault
	End If
End Sub

private Sub getArray_B(aarray() As Byte,akey As Int) As Object
	Return aarray(akey)
End Sub

private Sub getArray_C(aarray() As Char,akey As Int) As Object
	Return aarray(akey)
End Sub

private Sub getArray_S(aarray() As Short,akey As Int) As Object
	Return aarray(akey)
End Sub

private Sub getArray_I(aarray() As Int,akey As Int) As Object
	Return aarray(akey)
End Sub

private Sub getArray_J(aarray() As Long,akey As Int) As Object
	Return aarray(akey)
End Sub

private Sub getArray_F(aarray() As Float,akey As Int) As Object
	Return aarray(akey)
End Sub

private Sub getArray_D(aarray() As Double,akey As Int) As Object
	Return aarray(akey)
End Sub

private Sub getArray_L(aarray() As String,akey As Int) As Object
	Return aarray(akey)
End Sub

private Sub getArrayOfMap(aarray() As Map,akey As Int) As Object
	Return aarray(akey)
End Sub

private Sub getArrayOfList(aarray() As List,akey As Int) As Object
	Return aarray(akey)
End Sub

private Sub getArrayOfArray(aarray() As Object,akey As Int) As Object
	Return aarray(akey)
End Sub

public Sub get(avalue As Object,apath As String,adefault As Object) As Object
	Dim r As Object=adefault
	Dim o As Object=avalue
	Dim i As Int=0
	Dim t As Boolean=False
	Dim s() As String=Regex.split("\.", apath)
	Dim u As String
	Dim d As Int
	Try
		Do While Not(t)
			If o Is Map Then
				o=getMap(o,s(i),adefault)
			Else
				If o Is List Then
					o=getList(o,s(i),adefault)
				Else
					u=GetType(o)
					d=s(i)
					If u="[Lanywheresoftware.b4a.objects.collections.Map;" Then
						o=getArrayOfMap(o,d)
					Else
						If u="[Lanywheresoftware.b4a.objects.collections.List;" Then
							o=getArrayOfList(o,d)
						Else
							If u.SubString2(0,2)="[[" Then
								o=getArrayOfArray(o,d)
							Else
								Select Case u.SubString2(1,2)
									Case "B"
										o=getArray_B(o,d)
									Case "C"
										o=getArray_C(o,d)
									Case "S"
										o=getArray_S(o,d)
									Case "I"
										o=getArray_I(o,d)
									Case "J"
										o=getArray_J(o,d)
									Case "F"
										o=getArray_F(o,d)
									Case "D"
										o=getArray_D(o,d)
									Case "L"
										o=getArray_L(o,d)
									Case Else
										t=True
										o=adefault
								End Select
							End If
						End If
					End If
				End If
			End If
			If Not(t) Then
				i=i+1
				If i=s.Length Then
					t=True
					r=o
				End If
			End If
		Loop
	Catch
		Log(LastException.Message)
	End Try
	Return r
End Sub

